diff --git a/tools/checkasm.c b/tools/checkasm.c
index d33cfd3..6895988 100644
--- a/tools/checkasm.c
+++ b/tools/checkasm.c
@@ -257,7 +257,7 @@ static int check_dct( int cpu_ref, int cpu_new )
             fprintf( stderr, " - dct4x4dc :        [FAILED]\n" );
         }
     }
-    if( dct_asm.dct4x4dc != dct_ref.dct4x4dc )
+    if( dct_asm.idct4x4dc != dct_ref.idct4x4dc )
     {
         int16_t dct1[4][4] __attribute((aligned(16))) = { {-12, 42, 23, 67},{2, 90, 89,56}, {67,43,-76,91},{56,-78,-54,1}};
         int16_t dct2[4][4] __attribute((aligned(16))) = { {-12, 42, 23, 67},{2, 90, 89,56}, {67,43,-76,91},{56,-78,-54,1}};
@@ -626,6 +626,8 @@ static int check_quant( int cpu_ref, int cpu_new )
         TEST_DEQUANT( quant_8x8, dequant_8x8, CQM_8PY, 8 );
         TEST_DEQUANT( quant_4x4, dequant_4x4, CQM_4IY, 4 );
         TEST_DEQUANT( quant_4x4, dequant_4x4, CQM_4PY, 4 );
+
+        x264_cqm_delete( h );
     }
 
     ok = oks[0]; used_asm = used_asms[0];
@@ -684,7 +686,7 @@ static int check_intra( int cpu_ref, int cpu_new )
                 printf("%2x ", edge[16+k]);\
             printf("\n");\
             for(j=0; j<8; j++){\
-                printf("%2x ", edge[j]);\
+                printf("%2x ", edge[14-j]);\
                 for(k=0; k<8; k++)\
                     printf("%2x ", buf4[48+k+j*32]);\
                 printf("\n");\